"use strict";

var _ui = _interopRequireDefault(require("./ui"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('manager.ui.actions.ui', function () {
  describe('setStoryFilter', function () {
    it('should set the given filter', function () {
      var clientStore = {
        set: jest.fn()
      };
      var filter = 'kkkind';

      _ui.default.setStoryFilter({
        clientStore: clientStore
      }, filter);

      expect(clientStore.set).toHaveBeenCalledWith('storyFilter', filter);
    });
  });
  describe('toggleShortcutsHelp', function () {
    it('should toggle the client sotre accordingly', function () {
      var clientStore = {
        toggle: jest.fn()
      };

      _ui.default.toggleShortcutsHelp({
        clientStore: clientStore
      });

      expect(clientStore.toggle).toHaveBeenCalledWith('showShortcutsHelp');
    });
  });
  describe('selectAddonPanel', function () {
    it('should set the given panel name', function () {
      var clientStore = {
        set: jest.fn()
      };
      var panelName = 'kkkind';

      _ui.default.selectAddonPanel({
        clientStore: clientStore
      }, panelName);

      expect(clientStore.set).toHaveBeenCalledWith('selectedAddonPanel', panelName);
    });
  });
});