"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@storybook/react");

var _addonActions = require("@storybook/addon-actions");

var _index = _interopRequireDefault(require("./index"));

var _hierarchy = require("../../libs/hierarchy");

var _withLifecycleDecorator = _interopRequireDefault(require("../../../../libs/withLifecycleDecorator"));

var _compose = require("../../../../compose");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-line import/no-extraneous-dependencies
// eslint-disable-line import/no-extraneous-dependencies
var decorator = (0, _withLifecycleDecorator.default)({
  beforeEach: function beforeEach() {
    (0, _compose.setContext)({
      clientStore: {
        getAll: function getAll() {
          return {
            shortcutOptions: {},
            uiOptions: {},
            actions: {
              ui: {}
            }
          };
        },
        subscribe: function subscribe() {}
      }
    });
  },
  afterEach: function afterEach() {
    (0, _compose.setContext)(null);
  }
});
var storiesHierarchies = (0, _hierarchy.createHierarchies)([{
  kind: 'kk',
  namespaces: ['kk'],
  stories: ['bb']
}]);
var openShortcutsHelp = (0, _addonActions.action)('openShortcutsHelp');
var onStoryFilter = (0, _addonActions.action)('onStoryFilter');
(0, _react2.storiesOf)('UI|stories/StoriesPanel', module).addDecorator(decorator).add('default', function () {
  return _react.default.createElement(_index.default, {
    filter: "xxxxx",
    openShortcutsHelp: openShortcutsHelp,
    onStoryFilter: onStoryFilter
  });
}).add('with storiesHierarchies prop', function () {
  return _react.default.createElement(_index.default, {
    storiesHierarchies: storiesHierarchies,
    selectedKind: "kk",
    selectedStory: "bb",
    selectedHierarchy: ['kk'],
    openShortcutsHelp: openShortcutsHelp,
    onStoryFilter: onStoryFilter
  });
}).add('storiesHierarchies exists but is empty', function () {
  return _react.default.createElement(_index.default, {
    storiesHierarchies: (0, _hierarchy.createHierarchies)([]),
    openShortcutsHelp: openShortcutsHelp,
    onStoryFilter: onStoryFilter
  });
}).add('when open on mobile device', function () {
  return _react.default.createElement(_index.default, {
    storiesHierarchies: (0, _hierarchy.createHierarchies)([]),
    openShortcutsHelp: openShortcutsHelp,
    onStoryFilter: onStoryFilter,
    isMobileDevice: true
  });
});