"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@storybook/react");

var _index = _interopRequireDefault(require("./index"));

var _compose = require("../../../../../compose");

var _hierarchy = require("../../../libs/hierarchy");

var _filters = require("../../../libs/filters");

var _withLifecycleDecorator = _interopRequireDefault(require("../../../../../libs/withLifecycleDecorator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-line import/no-extraneous-dependencies
var data = (0, _hierarchy.createHierarchies)([{
  kind: 'a',
  name: 'a',
  namespaces: ['a'],
  stories: ['a1', 'a2']
}, {
  kind: 'b',
  name: 'b',
  namespaces: ['b'],
  stories: ['b1', 'b2']
}]);
var initialData = [{
  kind: 'some.name.item1',
  stories: ['a1', 'a2']
}, {
  kind: 'another.space.20',
  stories: ['b1', 'b2']
}];
var dataWithoutSeparator = (0, _hierarchy.createHierarchies)((0, _hierarchy.prepareStoriesForHierarchy)(initialData));
var dataWithSeparator = (0, _hierarchy.createHierarchies)((0, _hierarchy.prepareStoriesForHierarchy)(initialData, '\\.'));
var filter = 'th';
var selectedKind = 'another.space.20';
var filteredData = (0, _filters.storyFilter)((0, _hierarchy.prepareStoriesForHierarchy)(initialData, '\\.'), filter, selectedKind);
var filteredDataHierarchy = (0, _hierarchy.createHierarchies)(filteredData);
var decorator = (0, _withLifecycleDecorator.default)({
  beforeEach: function beforeEach() {
    (0, _compose.setContext)({
      clientStore: {
        getAll: function getAll() {
          return {
            shortcutOptions: {}
          };
        },
        subscribe: function subscribe() {}
      }
    });
  },
  afterEach: function afterEach() {
    (0, _compose.setContext)(null);
  }
});
(0, _react2.storiesOf)('UI|stories/Stories', module).addDecorator(decorator).add('empty', function () {
  return _react.default.createElement(_index.default, {
    storiesHierarchy: (0, _hierarchy.createHierarchies)([])[0],
    selectedKind: "",
    selectedStory: "",
    selectedHierarchy: []
  });
}).add('simple', function () {
  return _react.default.createElement(_index.default, {
    storiesHierarchy: data[0],
    selectedKind: "b",
    selectedStory: "b2",
    selectedHierarchy: ['b']
  });
}).add('with hierarchy - hierarchySeparator is defined', function () {
  return _react.default.createElement(_index.default, {
    storiesHierarchy: dataWithSeparator[0],
    selectedKind: "another.space.20",
    selectedStory: "b2",
    selectedHierarchy: ['another', 'space', '20']
  });
}).add('without hierarchy - hierarchySeparator is defined', function () {
  return _react.default.createElement(_index.default, {
    storiesHierarchy: dataWithoutSeparator[0],
    selectedKind: "another.space.20",
    selectedStory: "b2",
    selectedHierarchy: ['another.space.20']
  });
}).add('with highlighting when storiesFilter is provided', function () {
  return _react.default.createElement(_index.default, {
    storiesHierarchy: filteredDataHierarchy[0],
    selectedKind: selectedKind,
    selectedStory: "b2",
    selectedHierarchy: ['another', 'space', '20'],
    storyFilter: filter
  });
});