"use strict";

var _enzyme = require("enzyme");

var _tree_decorators_utils = require("./tree_decorators_utils");

describe('manager.ui.components.stories_panel.tree_decorators_utils.test', function () {
  describe('highlightNode', function () {
    test('should return name when there no highlighting matches', function () {
      var node = {
        name: 'some name',
        highlight: null
      };
      var result = (0, _tree_decorators_utils.highlightNode)(node);
      expect(result).toEqual('some name');
    });
    test('should return highlighted name when there matches', function () {
      var node = {
        name: 'some name',
        highlight: [[1, 3], [5, 7]]
      };
      var result = (0, _tree_decorators_utils.highlightNode)(node, {
        highLightText: {
          color: 'red'
        }
      });
      expect((0, _enzyme.shallow)(result[0]).html()).toEqual('<span>s</span>');
      expect((0, _enzyme.shallow)(result[1]).html()).toEqual('<strong style="color:red">ome</strong>');
      expect((0, _enzyme.shallow)(result[2]).html()).toEqual('<span> </span>');
      expect((0, _enzyme.shallow)(result[3]).html()).toEqual('<strong style="color:red">nam</strong>');
      expect((0, _enzyme.shallow)(result[4]).html()).toEqual('<span>e</span>');
    });
  });
});