"use strict";

var _addon_panel = require("./addon_panel");

describe('manager.ui.containers.addon_panel', function () {
  describe('mapper', function () {
    test('should give correct data', function () {
      var state = {
        selectedAddonPanel: 'sdp'
      };

      var selectAddonPanel = function selectAddonPanel() {
        return 'selectAddonPanel';
      };

      var panels = {
        test1: {},
        test2: {},
        sdp: {}
      };

      var getPanels = function getPanels() {
        return panels;
      };

      var props = {};
      var env = {
        actions: function actions() {
          return {
            ui: {
              selectAddonPanel: selectAddonPanel
            }
          };
        },
        context: function context() {
          return {
            provider: {
              getPanels: getPanels
            }
          };
        }
      };
      var result = (0, _addon_panel.mapper)(state, props, env);
      expect(result.panels).toEqual(panels);
      expect(result.selectedPanel).toEqual('sdp');
      expect(result.onPanelSelect).toBe(selectAddonPanel);
    });
  });
});