"use strict";

var _header = require("./header");

describe('manager.ui.containers.header', function () {
  describe('mapper', function () {
    test('should give correct data', function () {
      var uiOptions = {
        name: 'foo',
        url: 'bar'
      };
      var shortcutOptions = {
        showStoriesPanel: 'aa',
        enableShortcuts: true,
        addonPanelInRight: true
      };

      var toggleShortcutsHelp = function toggleShortcutsHelp() {
        return 'toggleShortcutsHelp';
      };

      var props = {};
      var env = {
        actions: function actions() {
          return {
            ui: {
              toggleShortcutsHelp: toggleShortcutsHelp
            }
          };
        }
      };
      var state = {
        uiOptions: uiOptions,
        shortcutOptions: shortcutOptions
      };
      var result = (0, _header.mapper)(state, props, env);
      expect(result.openShortcutsHelp).toBe(toggleShortcutsHelp);
      expect(result.enableShortcutsHelp).toEqual(shortcutOptions.enableShortcuts);
      expect(result.addonPanelInRight).toEqual(true);
      var stateWhenMobileDevice = {
        uiOptions: uiOptions,
        shortcutOptions: shortcutOptions,
        isMobileDevice: true
      };
      var resultWhenMobileDevice = (0, _header.mapper)(stateWhenMobileDevice, props, env);
      expect(resultWhenMobileDevice.addonPanelInRight).toEqual(false);
    });
  });
});