"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapper = mapper;
exports.RoutedLink = exports.MenuLink = void 0;

require("core-js/modules/es6.array.for-each");

require("core-js/modules/es6.array.filter");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.define-property");

var _components = require("@storybook/components");

var _gen_podda_loader = _interopRequireDefault(require("../libs/gen_podda_loader"));

var _handle_routing = require("../configs/handle_routing");

var _compose = _interopRequireDefault(require("../../../compose"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function mapper(state, props) {
  var _getUrlState = (0, _handle_routing.getUrlState)(_objectSpread({}, state, props.overrideParams)),
      url = _getUrlState.url;

  return {
    href: url
  };
}

var composer = (0, _compose.default)((0, _gen_podda_loader.default)(mapper), {
  withRef: false
});
var ComposedMenuLink = composer(_components.MenuLink);
exports.MenuLink = ComposedMenuLink;
var ComposedRoutedLink = composer(_components.RoutedLink);
exports.RoutedLink = ComposedRoutedLink;