"use strict";

var _search_box = require("./search_box");

describe('manager.ui.containers.search_box', function () {
  describe('mapper', function () {
    test('should give correct data', function () {
      var stories = [{
        kind: 'sk',
        stories: ['dd']
      }];
      var state = {
        shortcutOptions: {
          showSearchBox: true
        },
        stories: stories
      };

      var selectStory = function selectStory() {
        return 'selectStory';
      };

      var setOptions = jest.fn();
      var props = {};
      var env = {
        actions: function actions() {
          return {
            api: {
              selectStory: selectStory
            },
            shortcuts: {
              setOptions: setOptions
            }
          };
        }
      };
      var data = (0, _search_box.mapper)(state, props, env);
      var expectedData = {
        showSearchBox: true,
        stories: stories,
        onSelectStory: selectStory
      };
      expect(data).toMatchObject(expectedData);
      data.onClose();
      expect(setOptions).toHaveBeenCalledWith({
        showSearchBox: false
      });
    });
  });
});